//---------------------------------------------- 
//Author Info
//---------------------------------------------- 
SWEP.Author             = "Jamie Sharpe!" 
SWEP.Contact            = "me@jamiesharpe.co.uk" 
SWEP.Purpose            = "Spawn a large crate." 
SWEP.Instructions       = "Primary Fire: Spawn a large crate"
//---------------------------------------------
 
SWEP.Spawnable = true
SWEP.Adminspawnable = true
SWEP.ViewModel = "models/weapons/v_pistol.mdl"
SWEP.WorldModel = "models/weapons/w_pistol.mdl"
SWEP.HoldType = "pistol"
SWEP.Primary.Clipsize = -1
SWEP.Primary.DefaultClip = -1
SWEP.Primary.Automatic = false
SWEP.Primary.Ammo = "none"
SWEP.Secondary.Clipsize = -1
SWEP.Secondary.DefaultClip = -1
SWEP.Secondary.Automatic = false
SWEP.Secondary.Ammo = "none"
 
SWEP.RechargeTime = 0.5
SWEP.MaxDist = 200
 
local ShootSound = Sound ("Weapon_Pistol.Single")
 
function SWEP:Initialize()
        self.Weapon:SetNetworkedBool( "NextShot", 0 )
end
 
//--------------------------------------------
// Called when it reloads
//--------------------------------------------
function SWEP:Reload()
end
 
//--------------------------------------------
// Called each frame when the Swep is active
//--------------------------------------------
function SWEP:Think()
end 
 
//--------------------------------------------
// Called when the player Shoots
//--------------------------------------------
function SWEP:PrimaryAttack()
        local tr = self.Owner:GetEyeTrace()
        if self.Weapon:GetNetworkedFloat("NextShot") > CurTime() then return end
        
        local hitPosition = tr.HitPos
        local myPosition = self.Owner:GetPos()
        local distance = hitPosition:Distance(myPosition)
        if distance > self.MaxDist then return end
        self.BaseClass.ShootEffects(self)
        self:TakePrimaryAmmo(1)
        self.Weapon:EmitSound(ShootSound)
        self.Owner:ViewPunch( Angle( -1, 0, 0 ) )
        self.Weapon:SendWeaponAnim( ACT_VM_RECOIL1 )
        
        //self.Owner.NextSpawn = CurTime() + self.RechargeTime
        
        if !SERVER then return end
		self.Owner:SetNetworkedInt(self.Owner:GetNetworkedInt("Crates") + 1)
        self.Weapon:SetNetworkedBool( "NextShot", CurTime() + self.RechargeTime )
        
 --[[       local color = GetTeamColor(self.Owner)
        
        if BlueStatus2 == 0 && color == "Blue" then
            if tr.Entity:IsValid() then return end
        end
        if RedStatus2 == 0 && color == "Red" then
            if tr.Entity:IsValid() then return end
        end
        if YellowStatus2 == 0 && color == "Yellow" then
            if tr.Entity:IsValid() then return end
        end
        if GreenStatus2 == 0 && color == "Green" then
            if tr.Entity:IsValid() then return end
        end
]]--
        
        local ent = ents.Create("prop_physics")
        if ( !ent:IsValid() ) then
                return
        end
		
        ent:SetVar("OwnerID", self.Owner:SteamID())
        ent:SetModel("models/props_junk/wood_crate002a.mdl")
        ent:SetPos(hitPosition + Vector(0,0,23))
        ent:SetMaxHealth(500)
        ent:SetHealth(500)
--[[        local myTeam = self.Owner:Team()
        if myTeam == 1 then
            ent:SetColor(200,0,0,255)
        elseif myTeam == 2 then
            ent:SetColor(240,240,0,255)
        elseif myTeam == 3 then
            ent:SetColor(0,240,0,255)
        elseif myTeam == 4 then
            ent:SetColor(0,0,200,255)
        else
            ent:SetColor(255,0,255,255)
        end
]]--
        
        ent:Spawn()
        ent:Activate()
		
		local history = self.Owner:GetNWInt("Crates")
		self.Owner:SetNWInt("Crates", history + 1)
end
 
//-------------------------------------------- 
// Called when the player Uses secondary attack 
//-------------------------------------------- 
function SWEP:SecondaryAttack() 
        return
end
 
if !SERVER then
  --[[      function SWEP:DrawHUD()
				local myStatus = BLD[GetColorName(self.Owner:Team()).."2"]
                local tr = self.Owner:GetEyeTrace()
                local hitPosition = tr.HitPos
                local myPosition = self.Owner:GetPos()
                local distance = hitPosition:Distance(myPosition)
                
                if distance < self.MaxDist then
					local size = 8
					local border = 1
					draw.RoundedBox( 4, (ScrW()-size)/2-border, (ScrH()-size)/2-border, size+border*2, size+border*2, Color(0,0,0,255 ))
					if tr.Entity:IsValid() and !tr.Entity:IsPlayer() then
						if myStatus && myStatus > 0 then
							draw.RoundedBox( 4, (ScrW()-size)/2, (ScrH()-size)/2, size, size, Color(0,255,0,255-(0.5+0.5*math.sin(CurTime()*3))*100 ) )
						else
							draw.RoundedBox( 4, (ScrW()-size)/2, (ScrH()-size)/2, size, size, Color(255,0,0,255-(0.5+0.5*math.sin(CurTime()*3))*100 ) )
						end
					else
						draw.RoundedBox( 4, (ScrW()-size)/2, (ScrH()-size)/2, size, size, Color(0,255,0,255-(0.5+0.5*math.sin(CurTime()*3))*100 ) )
					end
                end
                
                
                if self.Weapon:GetNetworkedFloat("NextShot") > CurTime() then
                
                        local x,y = ScrW()/2, ScrH()/2
                        local s = 100
                        
                        local prog = math.Clamp((self.Weapon:GetNetworkedFloat("NextShot")-CurTime()) / self.RechargeTime,0,1)
                        
                        local poly_table = {}
                        local poly_info = {}
                        
                        local inner, outer = 15,23
                        local tic = 16
                        
                        local pi2 = math.pi*2
                        for i=0,tic-1 do
                                if i/tic > prog then
                                                poly_info[i] = 0
                                else
                                        if (i+1)/tic < prog then
                                                poly_info[i] = 1
                                        else
                                                poly_info[i] = (prog-(i/tic))*tic
                                        end
                                end
                                
                                poly_table[i] = {}
                                poly_table[i][1] = { u=0, v=0 } 
                                poly_table[i][1].x = x + outer*math.cos(i/tic*pi2) 
                                poly_table[i][1].y = y + outer*math.sin(i/tic*pi2)
                                
                                poly_table[i][2] = { u=0, v=0 }
                                poly_table[i][2].x = x + outer*math.cos((i+1)/tic*pi2)
                                poly_table[i][2].y = y + outer*math.sin((i+1)/tic*pi2)
                                
                                poly_table[i][3] = { u=0, v=0 }
                                poly_table[i][3].x = x + inner*math.cos((i+1)/tic*pi2)
                                poly_table[i][3].y = y + inner*math.sin((i+1)/tic*pi2)
                                
                                poly_table[i][4] = { u=0, v=0 }
                                poly_table[i][4].x = x + inner*math.cos(i/tic*pi2)
                                poly_table[i][4].y = y + inner*math.sin(i/tic*pi2)
                                
                        end
                        
                        //draw.RoundedBox( 4, x+(outer+15)*math.cos(prog*pi2)-4, y+(outer+15)*math.sin(prog*pi2)-4, 8,8, Color(255,255,0,255) )
                        
                        surface.SetTexture(surface.GetTextureID("white_outline"))
                        for i=0,tic-1 do
                                surface.SetDrawColor(255,255,255,poly_info[i]*255)
                                surface.DrawPoly( poly_table[i] )
                        end
                end
        end
]]--
end 
